
__no_init
struct
{
 u32 mcu_frq; 

 u8 init; 
} eep @ 0x4000; 

class //periph_init
{
 public:
 void ee()
 {
 #define sgn 0xba
  if(eep.init!=sgn)
  {
   FLASH_Unlock(FLASH_MEMTYPE_DATA);
   eep.mcu_frq  = (u32)16E6; 
   
   eep.init  = sgn;   
   FLASH_Lock(FLASH_MEMTYPE_DATA);
  }
 } 
 void gpio()
 {
  PA_CR1 = 0xff;
  PA_ODR = 0;  
  PA_DDR = 0;

  PB_CR1 = 0;
  PB_ODR = 0;
  PB_DDR = 0xff-(1<<5|1<<3);

  PC_CR1 = 0xff;
  PC_ODR = 0;
  PC_DDR = 0xff;

  PD_CR1 = 0xff;
  PD_ODR = 0;     
  PD_DDR = 0xff-2;

  PE_CR1 = 0;
  PE_ODR = 0;
  PE_DDR = 0xff;

  PF_CR1 = 0xff;
  PF_ODR = 0;
  PF_DDR = 0xff;
 }
 void clk()
 {
  CLK->PCKENR1 = CLK_PCKENR1_TIM1|CLK_PCKENR1_TIM4;
  CLK->PCKENR2 = CLK_PCKENR2_AWU|CLK_PCKENR2_ADC;
  CLK->CKDIVR  = 0; 
 }
 void t1()
 {
  TIM1->PSCRL = 0x0f;
  
  TIM1->CCMR1 = force_inactive|TIM1_CCMR_OCxPE; 
  TIM1->CCMR2 = force_inactive|TIM1_CCMR_OCxPE; 
  TIM1->CCMR3 = force_inactive|TIM1_CCMR_OCxPE; 
  TIM1->CCMR4 = force_inactive|TIM1_CCMR_OCxPE; 
  
  TIM1->CCER1 = TIM1_CCER1_CC1E|TIM1_CCER1_CC2E; 
  TIM1->CCER2 = TIM1_CCER2_CC3E|TIM1_CCER2_CC4E;
  TIM1->EGR   = TIM1_EGR_UG;

  TIM1->CR1   = TIM1_CR1_OPM;  
    
  TIM1->BKR   = TIM1_BKR_MOE;
 }
 void t2()  
 {
  TIM2->PSCR  = 8; // div256 -> 62,5kHz
  TIM2->CCMR2 = TIM2_ICSELECTION_DIRECTTI;
  TIM2->CCMR2|= 3<<4; //IC2f sampling=master, N=8;
  TIM2->IER   = TIM2_IER_CC2IE|TIM2_IER_UIE;
  TIM2->CCER1 = TIM2_CCER1_CC2P|TIM2_CCER1_CC2E; //active low 
  TIM2->CR1   = TIM2_CR1_URS|TIM2_CR1_CEN;
 }
 void t4()   //1000Hz
 {
   TIM4->ARR   = (u32)16E6/128/1000-1;
   TIM4->PSCR  = 7;
   TIM4->IER   = 1; 
   TIM4->CR1   = 1;
 }
 void adc()
 {
  ADC1->CR1  = ADC1_PRESSEL_FCPU_D18;
  ADC1->CR2  = ADC1_ALIGN_LEFT;
  ADC1->CSR  = 3;
  ADC1->TDRL = 0x0f;
  ADC1->CR1 |= ADC1_CR1_ADON;
  ADC1->CR1 |= ADC1_CR1_ADON;
 }
 void iwdg() 
 {
  IWDG_Enable();
  IWDG_WriteAccessCmd(IWDG_WriteAccess_Enable);
  IWDG_SetPrescaler(IWDG_Prescaler_256);
  IWDG_SetReload(0xff); 
  IWDG_ReloadCounter();
 }
}cfg;

